/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#pragma once

#include "Runtime/Launch/Resources/Version.h"

//Version flags
#if (ENGINE_MAJOR_VERSION == 4 && ENGINE_MINOR_VERSION >= 18) || ENGINE_MAJOR_VERSION == 5
#define UE_4_18_OR_LATER 1
#else
#define UE_4_18_OR_LATER 0
#endif

#if (ENGINE_MAJOR_VERSION == 4 && ENGINE_MINOR_VERSION >= 19) || ENGINE_MAJOR_VERSION == 5
#define UE_4_19_OR_LATER 1
#else
#define UE_4_19_OR_LATER 0
#endif

#if (ENGINE_MAJOR_VERSION == 4 && ENGINE_MINOR_VERSION >= 20) || ENGINE_MAJOR_VERSION == 5
#define UE_4_20_OR_LATER 1
#else
#define UE_4_20_OR_LATER 0
#endif

#if (ENGINE_MAJOR_VERSION == 4 && ENGINE_MINOR_VERSION >= 21) || ENGINE_MAJOR_VERSION == 5
#define UE_4_21_OR_LATER 1
#else
#define UE_4_21_OR_LATER 0
#endif

#if (ENGINE_MAJOR_VERSION == 4 && ENGINE_MINOR_VERSION >= 22) || ENGINE_MAJOR_VERSION == 5
#define UE_4_22_OR_LATER 1
#else
#define UE_4_22_OR_LATER 0
#endif

#if (ENGINE_MAJOR_VERSION == 4 && ENGINE_MINOR_VERSION >= 23) || ENGINE_MAJOR_VERSION == 5
#define UE_4_23_OR_LATER 1
#else
#define UE_4_23_OR_LATER 0
#endif

#if (ENGINE_MAJOR_VERSION == 4 && ENGINE_MINOR_VERSION >= 24) || ENGINE_MAJOR_VERSION == 5
#define UE_4_24_OR_LATER 1
#else
#define UE_4_24_OR_LATER 0
#endif

#if (ENGINE_MAJOR_VERSION == 4 && ENGINE_MINOR_VERSION >= 25) || ENGINE_MAJOR_VERSION == 5
#define UE_4_25_OR_LATER 1
#else
#define UE_4_25_OR_LATER 0
#endif

#if (ENGINE_MAJOR_VERSION == 4 && ENGINE_MINOR_VERSION >= 26) || ENGINE_MAJOR_VERSION == 5
#define UE_4_26_OR_LATER 1
#else
#define UE_4_26_OR_LATER 0
#endif

#if (ENGINE_MAJOR_VERSION == 4 && ENGINE_MINOR_VERSION >= 27) || ENGINE_MAJOR_VERSION == 5
#define UE_4_27_OR_LATER 1
#else
#define UE_4_27_OR_LATER 0
#endif

//Feature flags
#if UE_4_22_OR_LATER
#define MIXCAST_SHADER_PASSES 1
#else
#define MIXCAST_SHADER_PASSES 0
#endif

#if UE_4_26_OR_LATER
#define MIXCAST_D3D12 1
#else
#define MIXCAST_D3D12 0
#endif

#if UE_4_26_OR_LATER
#define MIXCAST_OPENXR 1
#else
#define MIXCAST_OPENXR 0
#endif